
uniform sampler2DRect tex;
uniform sampler2DRect lookupTex;
uniform float lookupSize;
uniform int lookupWidth;



#define Rec709GammaEncode(rgb)		mix(1.099 * pow(rgb, vec3(0.45)) - 0.099,  4.5 * rgb,  vec3(lessThan(rgb, vec3(0.018))))


void main()
{
	vec4 color0 = texture2DRect(tex, gl_TexCoord[0].st);
	vec3 linearRGB;
	
	vec3 p_indices = (color0.rgb * vec3(lookupSize - 1.0));
	vec3 y_coords  = floor(p_indices  / vec3(lookupWidth));
	vec3 x_coords  = mod(p_indices, vec3(lookupWidth));
	
	linearRGB.r = texture2DRect(lookupTex, vec2(x_coords[0], y_coords[0]) + vec2(0.5, 0.5)).r;
	linearRGB.g = texture2DRect(lookupTex, vec2(x_coords[1], y_coords[1]) + vec2(0.5, 0.5)).g;
	linearRGB.b = texture2DRect(lookupTex, vec2(x_coords[2], y_coords[2]) + vec2(0.5, 0.5)).b;
	gl_FragColor = vec4(Rec709GammaEncode(linearRGB), 1.0);
}

